//--------------------------------------------------------------------
//	
//	EditTextView.cpp
//
//	Written by: Robert Polic
//	
//	Copyright 1997 Be, Inc. All Rights Reserved.
//	
//--------------------------------------------------------------------

#include <stdlib.h>
#include <string.h>

#ifndef EDIT_TEXT_VIEW_H
#include "EditTextView.h"
#endif


//====================================================================

TEditTextView::TEditTextView(BRect frame, const char *name, BRect textRect,
							 long resizeMode, long flags,
							 const char* font, long size) :
		BTextView(frame, name, textRect, resizeMode, flags)
{
	strcpy(fFont, font);
	fSize = size;
}

//--------------------------------------------------------------------

bool TEditTextView::AcceptsChar(ulong key) const
{
	if (key == B_RETURN) {
		Window()->PostMessage(KILL_EDIT_SAVE);
		return FALSE;
	}
	else if (key == B_ESCAPE) {
		Window()->PostMessage(KILL_EDIT_NOSAVE);
		return FALSE;
	}
	else if ((key == B_TAB) || (key == B_DOWN_ARROW)) {
		Window()->PostMessage(NEXT_FIELD);
		return FALSE;
	}
	else if (key == B_UP_ARROW) {
		Window()->PostMessage(PREV_FIELD);
		return FALSE;
	}
	else if ((key < ' ') && (key != B_BACKSPACE) &&
			 (key != B_RIGHT_ARROW) && (key != B_LEFT_ARROW))
		return FALSE;
	else
		return TRUE;
}

//--------------------------------------------------------------------

void TEditTextView::AttachedToWindow()
{
	rgb_color	c;

	BTextView::AttachedToWindow();
	c.red = c.green = c.blue = 216;
	SetViewColor(c);
	SetFontName(fFont);
	SetFontSize(fSize);
	MakeFocus();
	SetLowColor(216, 216, 216);
	SetWordWrap(FALSE);
}
