//--------------------------------------------------------------------
//	
//	SaveWindow.h
//
//	Written by: Robert Polic
//	
//	Copyright 1997 Be, Inc. All Rights Reserved.
//	
//--------------------------------------------------------------------

#ifndef SAVE_WINDOW_H
#define SAVE_WINDOW_H

#ifndef _ALERT_H
#include <Alert.h>
#endif
#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef _CHECKBOX_H
#include <CheckBox.h>
#endif
#ifndef _BITMAP_H
#include <Bitmap.h>
#endif
#ifndef _BUTTON_H
#include <Button.h>
#endif
#ifndef _FILE_H
#include <File.h>
#endif
#ifndef _DIRECTORY_H
#include <Directory.h>
#endif
#ifndef _LIST_H
#include <List.h>
#endif
#ifndef _MENU_BAR_H
#include <MenuBar.h>
#endif
#ifndef _MENU_ITEM_H
#include <MenuItem.h>
#endif
#ifndef _OS_H
#include <OS.h>
#endif
#ifndef _POINT_H
#include <Point.h>
#endif
#ifndef _POP_UP_MENU_H
#include <PopUpMenu.h>
#endif
#ifndef _RECT_H
#include <Rect.h>
#endif
#ifndef _VIEW_H
#include <View.h>
#endif
#ifndef _VOLUME_H
#include <Volume.h>
#endif

#ifndef _WINDOW_H
#include <Window.h>
#endif

#include "AIFF.h"

#include "scsi.h"

#define SAVE_WIDTH			400
#define SAVE_HEIGHT			160

#define START_MENU_H		  7
#define START_MENU_V		 12
#define END_MENU_H			 23
#define END_MENU_V			 47

#define PLAY_BUTTON_H		 57
#define PLAY_BUTTON_V		126
#define STOP_BUTTON_H		162
#define STOP_BUTTON_V		126
#define SAVE_BUTTON_H		267
#define SAVE_BUTTON_V		126
#define SAVE_BUTTON_WIDTH	 75
#define SAVE_BUTTON_HEIGHT	 23
#define TRACK_TEXT_H		  6
#define TRACK_TEXT_V		 24
#define TRACK_MENU_H		 55
#define TRACK_MENU_V		 13
#define TRACK_MENU_WIDTH	126
#define TRACK_MENU_HEIGHT	 16
#define FORMAT_TEXT_H		250
#define FORMAT_TEXT_V		 24
#define FORMAT_MENU_H		330
#define FORMAT_MENU_V		 13
#define FORMAT_MENU_WIDTH	 63
#define FORMAT_MENU_HEIGHT	 16
#define DISK_TEXT_H			  6
#define DISK_TEXT_V			103
#define DISK_SPACE_H		 78
#define SELECTOR_H			  3
#define SELECTOR_V			 40
#define SELECTOR_HEIGHT		 48
#define DIVIDER				113

#define STATUS_WIDTH		300
#define STATUS_HEIGHT		 60
#define STATUS_BUTTON_WIDTH	 65
#define STATUS_BUTTON_HEIGHT 23
#define STATUS_BUTTON		  1
#define STATUS_MUTE_WIDTH	 45
#define STATUS_MUTE_HEIGHT	 13
#define STATUS_MUTE			  2
#define STATUS_TEXT_H		 10
#define STATUS_TEXT_V		 18
#define PROGRESS_H			 10
#define PROGRESS_V			 34
#define PROGRESS_WIDTH		205
#define PROGRESS_HEIGHT		 10

enum	save_buttons		{PLAY_BUT = 1, SAVE_BUT, STOP_BUT, AIFF, RAW, WAVE};
class	TSaveView;
class	TCDView;
class	TStatusView;

typedef struct {
	short	flags;
	char	title[256];
	long	length;
} track_info;
#define DIRTY	1


//====================================================================

class TSaveWindow : public BWindow {

private:

public:
int				fCDID;
short			fTrack;
BButton			*fPlayButton;
BButton			*fStopButton;
BButton			*fSaveButton;
BList			*fTitleList;
scsi_toc		*fTOC;
TSaveView		*fSaveView;

				TSaveWindow(BRect, char*, int, scsi_toc*, short, BList*);
				~TSaveWindow();
virtual void	MessageReceived(BMessage*);
virtual bool	QuitRequested();
virtual void	SaveRequested(record_ref, const char*);
virtual void	Show(short);
void			ResetMenu();
};

//--------------------------------------------------------------------

class TSaveView : public BView {

private:
int				fCDID;
long			fPos;
BBitmap			*fOffScreen;
BView			*fOffView;
TSaveWindow		*fWindow;

public:
short			fLastx;
long			fTrackStart;
long			fTrackLength;
long			fStart;
long			fStop;
BPopUpMenu		*fTrackMenu;
BPopUpMenu		*fFormatMenu;

				TSaveView(BRect, char*, TSaveWindow*, int);
				~TSaveView();
virtual	void	AttachedToWindow();
virtual	void	Draw(BRect);
virtual void	MouseDown(BPoint);
virtual void	Pulse();
void			DrawDiskSpace();
void			DrawSelector();
};

//====================================================================

class TStatusWindow : public BWindow {

public:
int				fCDID;
bool			fStop;
TStatusView		*fView;

				TStatusWindow(BRect, char*, BFile*, long, long, long, int);
virtual void	MessageReceived(BMessage*);
};

//--------------------------------------------------------------------

class TStatusView : public BView {

private:

public:
int				fCDID;
long			fTrackStart;
long			fStart;
long			fStop;
BFile			*fFile;
TStatusWindow	*fWind;

				TStatusView(BRect, char*, BFile*, long, long,
							long, TStatusWindow*, int); 
virtual void	AttachedToWindow();
virtual	void	Draw(BRect);
static  long	SaveThread(void*);
};
#endif
